import type { CollectionEntry } from "astro:content"

export type AbsolutePathname = `/${string}`

export type Project = CollectionEntry<"projects">

export type Operator = "AND" | "OR" | "NOT" | "IMPLICATION"

export type Table = boolean[][]

export type OrderOfOperation = {
  before: string
  after: string
  law: string
}

export type Expression = {
  leading: string
  left: Expression | null
  operator: Operator | null
  right: Expression | null
  trailing: string
  atomic: string | null
}

export type FetchResult = {
  status: string
  version: string | null
  before: string
  after: string
  orderOperations: OrderOfOperation[] | null
  expression: Expression | null
  header: string[] | null
  table: {
    truthMatrix: Table
  } | null
}

export type SimplifyTruthsOption = {
  name: string
  value: "NONE" | "TRUE" | "FALSE" | "DEFAULT" | "TRUE_FIRST" | "FALSE_FIRST"
}
